/*************************************************************

(C) ISEP 2004
(C) Professores de ADAV 2004

O ISEP, na qualidade de autor do presente software, garante 
o direito de utilizao, alterao, evoluo e distribuio 
do mesmo sem qualquer tipo de restries, excepto:
	- esta mensagem no pode ser retirada
	- os nomes das classes no podem ser alterados

*************************************************************/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using System.Data;
using ShopClassLibrary;

namespace WinShop
{
	/// <summary>
	/// Summary description for CustomerDetailsForm.
	/// </summary>
	public class CustomerDetailsForm : BaseForm
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.TextBox txtName;
		private System.Windows.Forms.TextBox txtAddress;
		private System.Windows.Forms.TextBox txtPhone;
		private System.Windows.Forms.TextBox txtFax;
		private System.Windows.Forms.TextBox txtEmail;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public CustomerDetailsForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private DataRow _customer;
		public DataRow Customer
		{
			set { _customer = value; }
			get { return _customer; }
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.txtName = new System.Windows.Forms.TextBox();
			this.txtAddress = new System.Windows.Forms.TextBox();
			this.txtPhone = new System.Windows.Forms.TextBox();
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.txtFax = new System.Windows.Forms.TextBox();
			this.txtEmail = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 88);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 23);
			this.label1.TabIndex = 10;
			this.label1.Text = "Name:";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 120);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 23);
			this.label2.TabIndex = 11;
			this.label2.Text = "Address:";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 192);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(56, 23);
			this.label5.TabIndex = 12;
			this.label5.Text = "Phone:";
			// 
			// txtName
			// 
			this.txtName.Location = new System.Drawing.Point(64, 88);
			this.txtName.Name = "txtName";
			this.txtName.Size = new System.Drawing.Size(216, 20);
			this.txtName.TabIndex = 13;
			this.txtName.Text = "";
			// 
			// txtAddress
			// 
			this.txtAddress.Location = new System.Drawing.Point(64, 120);
			this.txtAddress.Multiline = true;
			this.txtAddress.Name = "txtAddress";
			this.txtAddress.Size = new System.Drawing.Size(320, 64);
			this.txtAddress.TabIndex = 14;
			this.txtAddress.Text = "";
			// 
			// txtPhone
			// 
			this.txtPhone.Location = new System.Drawing.Point(64, 192);
			this.txtPhone.Name = "txtPhone";
			this.txtPhone.Size = new System.Drawing.Size(128, 20);
			this.txtPhone.TabIndex = 15;
			this.txtPhone.Text = "";
			// 
			// btnOK
			// 
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(216, 288);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 16;
			this.btnOK.Text = "Ok";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(312, 288);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 17;
			this.btnCancel.Text = "Cancel";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 224);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(56, 23);
			this.label6.TabIndex = 18;
			this.label6.Text = "Fax:";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(8, 256);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(56, 23);
			this.label7.TabIndex = 19;
			this.label7.Text = "Email:";
			// 
			// txtFax
			// 
			this.txtFax.Location = new System.Drawing.Point(64, 224);
			this.txtFax.Name = "txtFax";
			this.txtFax.Size = new System.Drawing.Size(128, 20);
			this.txtFax.TabIndex = 20;
			this.txtFax.Text = "";
			// 
			// txtEmail
			// 
			this.txtEmail.Location = new System.Drawing.Point(64, 256);
			this.txtEmail.Name = "txtEmail";
			this.txtEmail.Size = new System.Drawing.Size(232, 20);
			this.txtEmail.TabIndex = 21;
			this.txtEmail.Text = "";
			// 
			// CustomerDetailsForm
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(390, 340);
			this.Controls.Add(this.txtEmail);
			this.Controls.Add(this.txtFax);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.txtPhone);
			this.Controls.Add(this.txtAddress);
			this.Controls.Add(this.txtName);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Name = "CustomerDetailsForm";
			this.Text = "Customer Details";
			this.Load += new System.EventHandler(this.CustomerDetailsForm_Load);
			this.Controls.SetChildIndex(this.label1, 0);
			this.Controls.SetChildIndex(this.label2, 0);
			this.Controls.SetChildIndex(this.label5, 0);
			this.Controls.SetChildIndex(this.txtName, 0);
			this.Controls.SetChildIndex(this.txtAddress, 0);
			this.Controls.SetChildIndex(this.txtPhone, 0);
			this.Controls.SetChildIndex(this.btnOK, 0);
			this.Controls.SetChildIndex(this.btnCancel, 0);
			this.Controls.SetChildIndex(this.label6, 0);
			this.Controls.SetChildIndex(this.label7, 0);
			this.Controls.SetChildIndex(this.txtFax, 0);
			this.Controls.SetChildIndex(this.txtEmail, 0);
			this.ResumeLayout(false);

		}
		#endregion

		private void CustomerDetailsForm_Load(object sender, System.EventArgs e)
		{
			if (_customer == null)
			{
				//
				// criar um registo de cliente sem dados para utilizao pelos formulrios de Add
				// era mais eficiente usar TypedDataSets!!!!
				//
				// ICustomer c = new Customer();
				ICustomer c = Factory.CreateCustomerService();
				DataSet ds = c.GetById(UserSettings.Username, UserSettings.Password, -1);
				_customer = ds.Tables[0].NewRow();
			}
			else
			{
				txtName.Text = (string)_customer["name"];
				if (!_customer.IsNull("address"))
					txtAddress.Text = (string)_customer["address"];
				if (!_customer.IsNull("phonenb"))
					txtPhone.Text = (string)_customer["phonenb"];
				if (!_customer.IsNull("faxnb"))
					txtFax.Text = (string)_customer["faxnb"];
				if (!_customer.IsNull("email"))
					txtEmail.Text = (string)_customer["email"];
			}
		}

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			// copiar valores eliminando espaos em branco
			_customer["name"]=txtName.Text.Trim();
			_customer["address"]=txtAddress.Text.Trim();
			_customer["phonenb"]=txtPhone.Text.Trim();
			_customer["faxnb"]=txtFax.Text.Trim();
			_customer["email"]=txtEmail.Text.Trim();

			this.DialogResult = DialogResult.OK;
		}
	}
}
